/////////////////////////////////////////////////////////////////////////////
// Name:        BoxRoom_Goto.h
// Purpose:     One of BoxRoom's implemented files.
// Author:      Hellwolf Misty
// Modified by:
// Created:     2004/12/25
// Copyright:   (c) Hellwolf Misty
// Licence:     GNU GENERAL PUBLIC LICENSE
/////////////////////////////////////////////////////////////////////////////
#include "BoxRoom.h"
#include <list>
#include <utility>
using std::list;
using std::pair;
USING_NAMESPACE_BOXMAN


short   BoxRoom::MovePush(Direction d){
    //˵µλ
    Position nman = m_manpos+m_dir_offset[d];
    if(is_valid_position(nman) && is_adjacent_position(nman,m_manpos)){
        if(IsFloor(nman)){
            m_manpos = nman;
            m_totlestep++;
            return m_manpos;
        }
        if(IsBox(nman)){
            //ӵµλ
            Position nbox = nman+m_dir_offset[d];
            if(is_valid_position(nbox) && is_adjacent_position(nbox,m_manpos) && IsFloor(nbox)){
                m_map[nbox] = EM_BOX   | (m_map[nbox] & TARGET_BIT);
                m_map[nman] = EM_FLOOR | (m_map[nman] & TARGET_BIT);
                m_manpos = nman;
                m_totlestep++;
                return m_manpos;
            }
        }
    }
    return -1;
}

short   BoxRoom::Goto(Position p){
    short s = GotoDistance(p);
    if(s == -1)return -1;
    else{
        m_manpos = p;
        m_totlestep += s;
        return s;
    }
}

short   BoxRoom::Goto(Position p, MovePath& path){
    short s = GetPath(p,path);
    if(s == -1)return -1;
    else{
        m_manpos = p;
        m_totlestep += s;
        return s;
    }
}

short   BoxRoom::GotoDistance(Position p)const{
    /*
    Dijkstra㷨·:
    1 ·ʼûбĵ㣬OPENеȴ顣
    2 OPENҳʼĵ㣬ҳӽڵ㣬ŵCLOSEС
    3 ӽڵ㡣Щӽڵʼľֵӽڵ㵽OPENС
    4 ظ23ֱOPENΪգҵĿ㡣
    */
    if(is_not_valid_position(p) || IsNotFloor(p))return -1;

    if( p == m_manpos )return 0;
    list<Position>   openlist;
    vector<short>    distance_table(m_size,-1);//㵽˵λõ̾
    openlist.push_back(m_manpos);distance_table[m_manpos] = 0;
    while(!(openlist.empty())){
        Position    checknow = openlist.front();openlist.pop_front();
        for(int i = 0; i < 4; ++i){
            Position next = checknow + m_dir_offset[i];
            if(is_not_valid_position(next) || is_not_adjacent_position(next,checknow))continue;
            if(next == p)return distance_table[checknow] + 1;
            if(distance_table[next] == -1 && IsFloor(next)){
                openlist.push_back(next);
                distance_table[next] = distance_table[checknow] + 1;
            }
        }
    }
    return -1;
}

short   BoxRoom::GetPath(Position p, MovePath& path)const{
    MovePath result;
    //DistanceֻǶһ¼·
    if(is_not_valid_position(p) || IsNotFloor(p))return -1;

    if( p == m_manpos )return 0;
    list<Position>   openlist;
    //first:㵽˵λõ̾
    //second:ڵ㵽һҪƶķ
    vector<pair<int,Direction> >      check_table(m_size,pair<short,Direction>(-1,WEST));
    openlist.push_back(m_manpos);check_table[m_manpos].first = 0;
    while(!(openlist.empty())){
        Position    checknow = openlist.front();openlist.pop_front();
        for(int i = 0; i < 4; ++i){
            Position next = checknow + m_dir_offset[i];
            if(is_not_valid_position(next) || is_not_adjacent_position(next,checknow))continue;
            if(next == p){
                check_table[next].first = check_table[checknow].first + 1;
                check_table[next].second = static_cast<Direction>(i);
                checknow = next;
                do{
                    Direction tmpd = check_table[checknow].second;
                    checknow = checknow + m_dir_offset[REVERSE_DIRECTION(tmpd)];
                    result.push_front(tmpd);
                }while(checknow != m_manpos);
                path.insert(path.end(),result.begin(),result.end());
                return static_cast<int>(result.size());
            }
            if(check_table[next].first == -1 && IsFloor(next)){
                openlist.push_back(next);
                check_table[next].first = check_table[checknow].first + 1;
                check_table[next].second = static_cast<Direction>(i);
            }
        }
    }
    return -1;
}

