/////////////////////////////////////////////////////////////////////////////
// Name:        BoxMan.cpp
// Purpose:     BoxMan MainFrame
// Author:      Hellwolf Misty
// Modified by:
// Created:     2004/12/29
// Copyright:   (c) Hellwolf Misty
// Licence:     GNU GENERAL PUBLIC LICENSE
/////////////////////////////////////////////////////////////////////////////
#include    "BoxMan.h"
#include    "../base/prog_info.h"

class BoxManApp : public wxApp
{
public:
    virtual bool OnInit(){
        wxImage::AddHandler( new wxCURHandler );
        BoxManFrame*    frame =  new BoxManFrame();
        frame->Show();
        return true;
    }
};

IMPLEMENT_APP(BoxManApp)

BEGIN_EVENT_TABLE(BoxManFrame, wxFrame)
EVT_MENU(MENU_GAME_EXIT,BoxManFrame::OnExit)
EVT_MENU(MENU_GAME_SELECTGAME,BoxManFrame::NewRoom)
EVT_MENU(MENU_TOOL_SOLVE,BoxManFrame::ToolSolve)
EVT_MENU(MENU_HELP_ABOUT,BoxManFrame::OnAbout)
EVT_MENU(MENU_HELP_HOWTO,BoxManFrame::OnHowTo)
EVT_UPDATE_UI(MENU_GAME_SELECTGAME,BoxManFrame::OnUpdateUI)
END_EVENT_TABLE()

BoxManFrame::BoxManFrame():wxFrame((wxFrame *)NULL, -1, wxString(prog_name)){
    SetIcon(wxIcon("RES/app.ico"));
    wxMenu* GameMenu = new wxMenu;
    GameMenu->Append(MENU_GAME_SELECTGAME,_T("ؿļ(&L)\tCtrl-L"));
    GameMenu->AppendSeparator();
    GameMenu->Append(MENU_GAME_EXIT,_T("˳(&X)\tCtrl-X"));

    wxMenu* ToolMenu = new wxMenu;
    ToolMenu->Append(MENU_TOOL_SOLVE,_T("Զ(&S)\tCtrl-S"));

    wxMenu* HelpMenu = new wxMenu;
    HelpMenu->Append(MENU_HELP_HOWTO,_T("(&A)\tCtrl-H"));
    HelpMenu->Append(MENU_HELP_ABOUT,_T("(&A)\tCtrl-A"));

    wxMenuBar *boxman_menubar = new wxMenuBar( wxMB_DOCKABLE );

    boxman_menubar->Append(GameMenu,_T("Ϸ(&G)"));
    boxman_menubar->Append(ToolMenu,_T("(&T)"));
    boxman_menubar->Append(HelpMenu,_T("(&H)"));

    SetMenuBar(boxman_menubar);
    CreateStatusBar(2);
    UpdateStatusBar();

    Maximize(true);
    wxSize  _size = GetClientSize();
    canvas = new PlayModeCanvas(this,room);canvas->SetSize(0,0,_size.GetX(),_size.GetY());
};

void BoxManFrame::OnExit(wxCommandEvent& event){
    Close(true);
}

void BoxManFrame::NewRoom(wxCommandEvent& event){
    wxString filename = wxFileSelector(_T("ѡؿ"),"../Stages/","","",
        "ؿļ(*.xsb)|*.xsb|"
        "ļ | *");
    if (!filename)return;
    room.LoadFile(filename.ToAscii());
    canvas->UpdateAll();
    canvas->Enable();
}

void BoxManFrame::ToolSolve(wxCommandEvent& event){
    canvas->ShowSolveResult();
}

void    BoxManFrame::UpdateStatusBar(){
    wxString    str;
    str.Printf(_T("Ѿ߹Ĳ%d"),room.GetTotlestep());
    SetStatusText(str,0);

    str.clear();
    if(IsBoxRoomDead(room))
        str.append(_T("һˣ\t"));
    if(room.IsFinished()){
        str.append(_T("Ӯˣ\t"));
    }
    SetStatusText(str,1);
}

void    BoxManFrame::OnUpdateUI(wxUpdateUIEvent& event){
    UpdateStatusBar();
}

void    BoxManFrame::OnAbout(wxCommandEvent& event){
    wxMessageBox(box_man_about,"");
}

void    BoxManFrame::OnHowTo(wxCommandEvent& event){
    char*   box_man_how_to_gui = 
        "Ҽƶ˹ҿ\n"
        "Сƶ˹ĿĵأɴĻ\n"
        "Ҽƶ\n"
        "SԶ⣬ں̨УӰϷBUG:ﲻҪؿ\n";
    wxMessageBox(box_man_how_to_gui,"");
}
